/*********************************************
Compiler            : CodeVision    
Hardware            : AVR-Ctrl
Chip type           : AT90S8535
Clock frequency     : 8,000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>
#include <delay.h>
// Declare your global variables here

#define UP     0
#define DOWN   1

void main(void)
{

// Declare your local variables here
unsigned char led = 0x01;
unsigned char direction = UP;

delay_ms(100); 

// Input/Output Ports initialization
// Port A
PORTA=0x00;
DDRA=0x00;

// Port B
PORTB=0x00;
DDRB=0xFF;            // all output

// Port C
PORTC=0x00;
DDRC=0x00;

// Port D
PORTD=0x00;             
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Output Compare
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Output Compare
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Output Compare
// OC2 output: Disconnected
TCCR2=0x00;
ASSR=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

while (1)
      {
         PORTB = led;                // output data
         delay_ms(100);              // wait
         if (direction == UP)        // up?
          { led <<=1;                // shift 1 up
            if (led == 0)            // end?
             { led = 0x80;
               direction = DOWN;     // change direction
             }  
          }
         else   
          { led >>=1;                // shift 1 down
            if (led == 0) 
             { led = 0x01;
               direction = UP;
             }  
          }
       
      };
}
